
--XNvg[h
--_G.OnReload = function() print("map_scene _G.OnReload") end

--V[NX
Class("map_scene", scene)({})

--RXgN^
function map_scene:constructor(...)
	self.super:constructor(...)

	--oϐ
	self.mCount = 0                         --CJE^
	self.mLight = DirectionalLightC()       --sCg̍쐬
	self.mMapList = nil                     --}bvXg
	self.mMapMatrixList = nil               --}bv̍s񃊃Xg
	self.mMapVisualList = nil               --}bv̎oXg
	self.mShineState = state:factory()      --LLGtFNg̏
	self.mCamera = camera:factory()         --J̍쐬
	self.mPlayer = player_chara:factory()   --vC[̍쐬
	self.mFade = fade:factory()             --tF[hiCxg̉ʌʓj̍쐬
	self.mParticle = {}                     --p[eBNꊇǗpe[u̍쐬
	self.mPrePushPullAnime = "none"         --ỎAj
	self.mPushPullAnime = "none"            --Aj
	self.mPushPullCount = 0                 --̃JE^
	self.mBGMDiff = -500                    --BGM̉ʒ
	self.mPreJumpVoiceNum = 2               --ÕWvԍ

	--蔻
	self.mHitData = {
		wallNormal = Vector3C(), --ǂ̖@
	}

	--JƃvC[̋
	self.mCamera:SetRange(150)

	--Cg̐ݒ
	self.mLight:Enabled(true)
	self.mLight:SetDirection(Vector3C(1.0, -1.0, 0.0):Normalize() )
	self.mLight:Apply()

	--ArGgCeBOݒ
	--DEVICE:SetAmbient(COLOR(255, 0, 0, 0) )

	--tHOݒ
	DEVICE:SetFogState(COLOR(255, 255, 170, 0), 100, 6000)
end

--s֐
function map_scene:Run()

	--nʂɂꍇAyo
	if self.mPlayer.mOnLandFlag == true and self.mPlayer.mPreOnLandFlag == false then

		--ỹp[eBN쐬
		particle.SpreadDirtyDust(self.mParticle, self.mPlayer.mPosition, 8, 1.5, 40, 0.35)
	end

	--LLGtFNggpꂽꍇALLo
	local shineNum = self.mShineState.mCount / 2
	if self.mShineState.mFlag == true and self.mShineState.mCount % 2 == 0 then

		--nP[̂ƂAHTU炷
		if game.data.now_neji == "hurricane" then
			particle.Feather(self.mParticle, self.mPlayer.mPosition, rand.s_range(0, 359), 6, 50, rand.s_range(0, 3), 0.2)

		--}b`lŴƂAԂ͋GtFNgo
		elseif game.data.now_neji == "muscle" then
			particle.Power(self.mParticle, self.mPlayer.mPosition, 1, 0.3, 50, 0.2, 0.02)
		end

		--ԂoĂΏI
		if 60*2 < self.mShineState.mCount then self.mShineState:Change(false) end
	end

	--p[eBN̊ʒuvC[ʒu
	particle.mBasePosition:Set(self.mPlayer.mPosition)

	--LLGtFNg̍XV
	self.mShineState:CountUp(1)

	--tF[h̍XV
	self.mFade:Run()

	--p[eBN̍XV
	for i, value in ipairs(self.mParticle) do value:Run(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS) end

	--p[eBN̍폜XV
	FillTable(self.mParticle, "mDeleteFlag")

	--3DTEh̃Xi[ݒ
	local direction = TMP_VECTOR:Set(self.mPlayer.mPosition - self.mCamera.mPosition)
	WAVESOUND:SetListenerPosition(self.mCamera.mPosition)
	WAVESOUND:SetListenerVelocity(self.mCamera.mPosition - self.mCamera.mPrePosition)
	WAVESOUND:SetListenerFront(direction:Normalize() )
	WAVESOUND:SetListenerTop(Y_AXIS)
end

--fobOo
function map_scene:DebugMessage()
	LUA:DebugOut("JE^", self.mCount)
	LUA:DebugOut("vC[ʒu", VecToString(self.mPlayer.mPosition) )
	LUA:DebugOut("Jʒu", VecToString(self.mCamera.mPosition) )
	LUA:DebugOut("J_", VecToString(self.mCamera.mAt) )
	LUA:DebugOut("p[eBN", #self.mParticle)
	LUA:DebugOut("lW", game.data.now_neji)
end

--fXgN^iOR[j
function map_scene:destructor()

	--vC[̉
	self.mPlayer:destructor()
	self.mPlayer = nil

	--tF[hCEAEg̉
	self.mFade:destructor()
	self.mFade = nil

	--p[eBNe[u
	DeleteTable(self.mParticle)

	--`IuWFNg̉
	RENDERER:Clear()

	--fobOo͂NA
	LUA:DebugClear()
end

--[h֐
function map_scene:OnReload()
end

--VhE}bv̐ݒ菈
function map_scene:SetShadowSetting()

	--ef[^쐬̂߂̃Cg̏Ԃݒ
	local lightAt  = TMP_VECTOR_A:Set(self.mPlayer.mPosition)
	local lightPos = TMP_VECTOR:Set(lightAt.x + 0.1, lightAt.y + 100, lightAt.z)
	local lightUp  = TMP_VECTOR_B:Set(0, 1.0, 0)
	local proj = TMP_MATRIX:OrthoLH(70, 70, 0, 2000)
	local view = TMP_MATRIX_A:LookAtLH(lightPos, lightAt, lightUp)
	SHADOWMAP:SetLightProjection(proj)
	SHADOWMAP:SetLightView(view)

	--ef[^̍폜
	SHADOWMAP:RemoveShadowData()

	--ef[^̍쐬FvC[
	for key, model in pairs(self.mPlayer.mPartsList) do
		SHADOWMAP:SaveShadowData(model)
	end
end

--}bṽXgɍsݒ肷ys񃊃Xg̃o, oXg̃o, Zbgsz
function map_scene:SetListMatrix(mapMatrixListMember, mapVisualListMember, matrix)
	self.mMapMatrixList[mapMatrixListMember]:Set(matrix)
	self.mMapVisualList[mapVisualListMember]:SetMatrix(matrix)
end

--Xe[W̃IuWFNgp̓yoyʒu, TCY, őJEg, g, Yړʁz
function map_scene:DirtyDust(position, scale, max, plusScale, plusY)

	--p[eBN쐬ăe[uɓo^
	particle.DirtyDust(self.mParticle, position, scale, max, plusScale, plusY)
end

--vC[̃[}C擾̃LLGtFNgo
function map_scene:Shine()
	self.mShineState:Change(true)
end

--vC[ړ
function map_scene:PlayerMove()

	--z[hԂłꍇ͈ړȂ
	if self.mPlayer.mHoldState.mFlag == true then
		return false
	end

	--[Jϐ錾
	local camDir = TMP_VECTOR      --J
	local keyTmp = TMP_VECTOR_A    --Kp
	local lengthTmp = TMP_VECTOR_B --p
	local moveFlag = false         --ړ

	--J̕lvC[ɂƂĂ̑OxNg
	camDir:Set(self.mCamera.mAt - self.mCamera.mPosition)
	camDir.y = 0

	--L[{[hɈ˂ړ
	local moveX = 0
	local moveY = 0
	moveX = moveX + (0 < INPUT.LEFT and -1.0 or 0.0)
	moveX = moveX + (0 < INPUT.RIGHT and 1.0 or 0.0)
	moveY = moveY + (0 < INPUT.FORE and -1.0 or 0.0)
	moveY = moveY + (0 < INPUT.BACK and 1.0 or 0.0)
	keyTmp:Set(moveX, moveY, 0):Normalize()

	--L[{[h͂Ă
	if 0 < INPUT.FORE or 0 < INPUT.BACK or 0 < INPUT.LEFT or 0 < INPUT.RIGHT then

		--nʂɐGĂ邵AWvĂȂ
		if self.mPlayer.mOnLandFlag == true and self.mPlayer.mJumpStartFlag == false then
			self.mPlayer:MoveDirection(camDir, keyTmp.x, keyTmp.y)
			self.mPlayer:ChangeSpeed(1.0)
			moveFlag = true

		--Wv
		elseif self.mPlayer.mJumpStartFlag == true then
			self.mPlayer:JumpMoveDirection(camDir, keyTmp.x, keyTmp.y)
		end

	--(L[{[h̓͂Ȃꍇ)WCpbhɈ˂ړ
	else

		--WCpbh̓͂Ă
		moveX = INPUT.LEFT_H / I.J_MAX
		moveY = INPUT.LEFT_V / I.J_MAX
		if moveX ~= 0 or moveY ~= 0 then

			--nʂɐGĂ邵AWvĂȂ
			if self.mPlayer.mOnLandFlag == true and self.mPlayer.mJumpStartFlag == false then
				self.mPlayer:MoveDirection(camDir, moveX, moveY)
				local length = lengthTmp:Set(moveX, moveY, 0):GetLength()
				length = (1.0 <= length) and 1.0 or length
				self.mPlayer:ChangeSpeed(length)
				moveFlag = true

			--Wv
			elseif self.mPlayer.mJumpStartFlag == true and (moveX ~= 0 or moveY ~= 0) then
				self.mPlayer:JumpMoveDirection(camDir, moveX, moveY)
			end
		end
	end

	--yp[eBN쐬
	if moveFlag == true then
		particle.KickDirtyDust(self.mParticle, self.mPlayer.mPosition, self.mPlayer:GetUnitSpeed(), 2.0, 0.6, 0.3)
	end

	--
	return moveFlag
end

--vC[̃lWŗL̃ANV𔻒fčs
function map_scene:RunPlayerNejiAction()
	if game.data.now_neji == "hurricane" then
		self:PlayerJump()
	elseif game.data.now_neji == "muscle" then
		self:PlayerPushPull()
	end
end

--vC[̃Wv
function map_scene:PlayerJump()

	--nʂɂ
	if self.mPlayer.mJumpStartFlag == true and self.mPlayer.mOnLandFlag == true then

		--WvJntO܂
		self.mPlayer.mJumpStartFlag = false
	end

	--nʂɗĂƂɓ͂
	if INPUT.CANCEL == 1 and self.mPlayer.mOnLandFlag == true then

		--WvJn
		self.mPlayer.mJumpStartFlag = true
		self.mPlayer.mJumpCount = 0
		self.mPlayer.mGravity = 4
		self.mPlayer.mJumpContinueFlag = true
		self.mPlayer.mJumpVelocity:Set(self.mPlayer.mVelocity)
		self.mPlayer.mJumpAddVelocity:Set(0, 0, 0)

		--Wvɓỹp[eBN쐬
		particle.SpreadDirtyDust(self.mParticle, self.mPlayer.mPosition, 8, 2.0, 50, 0.4)

		--炷
		WAVESOUND:Play(WPath("kick_"..rand.range(0, 4) ), self.mPlayer.mPosition, self.mPlayer.mVelocity, 5, 200)

		--o
		local randNum = rand.range(0, 2)
		if randNum == mPreJumpVoiceNum then randNum = (randNum + 1) % 3 end
		if randNum == 0 then
			WAVESOUND:Play(WPath("jump_0"), self.mPlayer.mPosition, self.mPlayer.mVelocity, 100, 200)
		elseif randNum == 1 then
			WAVESOUND:Play(WPath("jump_1"), self.mPlayer.mPosition, self.mPlayer.mVelocity, 5, 200)
		elseif randNum == 2 then
			WAVESOUND:Play(WPath("jump_2"), self.mPlayer.mPosition, self.mPlayer.mVelocity, 5, 200)
		end
		mPreJumpVoiceNum = randNum
	end

	--xĂԃWv
	if 1 < INPUT.CANCEL and INPUT.CANCEL < 20 and self.mPlayer.mJumpStartFlag == true and self.mPlayer.mJumpContinueFlag == true then
		self.mPlayer.mGravity = 3
	end

	--L[𗣂Ă܂AĂ̓͂oȂ
	if INPUT.CANCEL == 0 and self.mPlayer.mJumpStartFlag == true then
		self.mPlayer.mJumpContinueFlag = false
	end
end

--vC[̉
function map_scene:PlayerPushPull()

	--nʂɌoĂ鎞Ƀ{^Ă
	if INPUT.CANCEL == 1 and self.mPlayer.mOnLandFlag == true then
		self.mPlayer.mPushPullState:Change(true)
	end

	--̕֏ړ
	if self.mPlayer.mPushPullState.mFlag == true and
		self.mPlayer.mPushPullState.mCount < 20 and self.mPlayer.mMoveFlag == false then
			local dir = TMP_VECTOR
			dir:Set(self.mPlayer.mDirection)
			dir.y = 0
			dir:Normalize()
			self.mPlayer.mPosition:Set(self.mPlayer.mPosition + dir * 0.07)
	end

	--Ȃ̎̓Xs[h𗎂Ƃ
	if self.mPlayer.mPushPullState.mFlag == true and 0.7 < self.mPlayer:GetUnitSpeed() then
		self.mPlayer:ChangeSpeed(0.7)
	end

	--莞ԂoĂΖ߂
	if self.mPlayer.mPushPullState.mCount == 40 then
		self.mPlayer.mPushPullState:Change(false)
	end

	--Ԃ̃JEgAbv
	self.mPlayer.mPushPullState:CountUp(1)
end

--vC[̃z[hԂ̍XVy蔻f[^, L, z[hAj[VŒ肷邩z
function map_scene:RunPlayerHold(hitData, enable, fixAnime)

	--JñAj[VŒ
	if fixAnime == true then

		--Aj[VXV
		self.mPlayer.mHoldAnime = self.mPushPullAnime
		return false, "none"
	end

	local camDir = TMP_VECTOR      --J
	local playerDir = TMP_VECTOR_A --vC[sׂ
	local moveFlag = false         --ړ
	local pushPullFlag = "none"    --Ă邩

	--J̕lvC[ɂƂĂ̑OxNg
	camDir:Set(self.mCamera.mAt - self.mCamera.mPosition)
	camDir.y = 0

	--L[{[hɈ˂
	local moveX = 0 + (0 < INPUT.LEFT and -1 or 0) + (0 < INPUT.RIGHT and 1 or 0)
	local moveY = 0 + (0 < INPUT.FORE and -1 or 0) + (0 < INPUT.BACK and 1 or 0)
	playerDir:Set(moveX, 0, moveY):Normalize()
	if moveX ~= 0 or moveY ~= 0 then
		moveFlag = true
	else
		--WCpbhɈ˂
		moveX = INPUT.LEFT_H / I.J_MAX
		moveY = INPUT.LEFT_V / I.J_MAX
		playerDir:Set(moveX, 0, moveY):Normalize()
		moveFlag = not (playerDir:GetLength() < 0.7)
	end

	--͂Ă
	if moveFlag == true then

		--Y]s
		local rotateY = TMP_MATRIX

		--Oƃ}CiXZƂ̊px擾
		local angle = camDir:GetAngle(Z_AXIS * -1):ToDeg() * (0 <= camDir.x and -1 or 1)

		--K؂ȕ擾
		rotateY:RotationY(DEG_ANGLE(-1 * angle) )
		playerDir:TransformCoord(rotateY)
		playerDir.x = playerDir.x * -1
		playerDir.y = playerDir.y * -1

		--px擾
		local angle = playerDir:GetAngle(hitData.wallNormal):ToDeg()
		if 0 <= angle and angle < 45 then
			pushPullFlag = "pull" 
		elseif 90+45 <= angle and angle < 180 then
			pushPullFlag = "push"
		else
			pushPullFlag = "none"
		end
	end

	--Aj[VXV
	self.mPlayer.mHoldAnime = pushPullFlag

	--z[h
	if INPUT.CANCEL == 0 or hitData.wallFlag == false then
		self.mPlayer.mHoldState:Change(false)
	end

	--vC[ʕiXY{ȊOjĂꍇɃz[h
	if self.mPlayer.mHoldState.mFlag == true and 15 == self.mPlayer.mHoldState.mCount then
		local angle = self.mPlayer.mGuideAngle
		if angle ~= 359 and angle ~= 0 and angle ~= 1 and angle ~= 89 and angle ~= 90 and angle ~= 91 and
			angle ~=179 and angle ~= 180 and angle ~= 181 and angle ~= 269 and angle ~= 270 and angle ~= 271 then
				self.mPlayer.mHoldState:Change(false)
		end
	end

	--z[h
	if self.mPlayer.mHoldState.mFlag == true then
		self.mPlayer:Stop()
		self.mPlayer.mPosition:Set(self.mPlayer.mPosition + hitData.wallNormal * -0.5)
	end
	
	--
	if hitData.wallFlag == true and self.mPlayer.mPushPullState.mFlag == true and enable == true then
		
		--͂Ăz[h
		if 0 < INPUT.CANCEL and self.mPlayer.mHoldState.mFlag == false and 10 < self.mPlayer.mHoldState.mCount then
			self.mPlayer.mHoldState:Change(true)
			self.mPlayer:MoveDirection(hitData.wallNormal, 0, 0.0001)
		end
	end

	--z[hԂł΃z[h炷
	if self.mPlayer.mHoldState.mFlag == true and self.mPlayer.mHoldState.mCount == 15 then
		WAVESOUND:Play(WPath("hold"), self.mPlayer.mPosition, self.mPlayer.mVelocity, 5, 150)
	end

	--z[h̃JEgAbv
	self.mPlayer.mHoldState:CountUp(1)

	--̏Ԃ𐔃JEgێł炻Ԃ
	local resultFlag = "none"
	if self.mPrePushPullAnime == pushPullFlag then
		self.mPushPullCount = self.mPushPullCount + 1
	else
		self.mPushPullCount = 0
	end
	if 30 < self.mPushPullCount then resultFlag = pushPullFlag end
	self.mPrePushPullAnime = pushPullFlag

	--vC[̉JniJñAjۑj
	if self.mPlayer.mHoldState.mFlag == true and resultFlag ~= "none" then
		self.mPushPullAnime = pushPullFlag
		return true, self.mPushPullAnime
	else
		return false, "none"
	end
end

--vC[ƃ}bvzuƂ̓蔻yWvĂ邩z
function map_scene:PlayerToMap(jumpFlag)

	--[Jϐ
	local charaPosition  = self.mPlayer.mPosition
	local charaDirection = self.mPlayer.mDirection
	local wallHitFlag    = false
	local wallHitFlag2   = false
	local landHitFlag    = false
	local wallTouch      = false
	local landType       = nil
	local wallName       = nil
	local landName       = nil
	local index          = -1
	local firstWallFlag  = false
	local min            = TMP_VECTOR
	local max            = TMP_VECTOR_A

	--Wvł
	if jumpFlag == true then

		--o^Ă郊Xg}ĂƓ蔻
		for key, resource in pairs(self.mMapList) do

			--VƂ̓蔻
			GetMinMax(self.mPlayer.mPosition, 50, 100, 50, min, max) --lAABB߂
			if AABBJudgment(XFILE:GetXFile(resource), self.mMapMatrixList[key], min, max) then
				ToCeiling(charaPosition, 25, 8, resource, self.mMapMatrixList[key])
			end
		end
	end

	--o^Ă郊Xg}ĂƓ蔻
	for key, resource in pairs(self.mMapList) do

		--e|
		local _wallHitFlag = false
		local _landHitFlag = false
		local _landType = nil

		--Ƃ̓蔻
		GetMinMax(self.mPlayer.mPosition, 50, 100, 50, min, max) --lAABB߂
		if AABBJudgment(XFILE:GetXFile(resource), self.mMapMatrixList[key], min, max) then
			_landHitFlag, _landType = ToLand(charaPosition, 15, 5.5, resource, self.mMapMatrixList[key])
		end

		--ĂԂۑ
		if _landHitFlag == true then
			landHitFlag = true
			landType = _landType
			landName = key
		end
	end

	--o^Ă郊Xg}ĂƓ蔻
	for key, resource in pairs(self.mMapList) do

		--e|
		local _wallHitFlag = false
		local _wallType = false
		local _wallTouch = false
		local _index = -1

		--ǂƂ̓蔻
		GetMinMax(self.mPlayer.mPosition, 100, 50, 100, min, max) --lAABB߂
		if AABBJudgment(XFILE:GetXFile(resource), self.mMapMatrixList[key], min, max) then
			_wallHitFlag, _wallType, _wallTouch, _index = 
				ToWall(charaPosition, charaDirection, 13, 2.5, resource, self.mMapMatrixList[key], self.mHitData.wallNormal)
		end

		--ǂƕǂ̊Ԃɋ܂`łꍇ͔I
		if _wallHitFlag == true and _wallType == true then
			wallHitFlag = true
			wallName = key
			break
		end

		--ĂԂۑ
		if _wallHitFlag == true then
			wallHitFlag = true
			wallName = key
			index = _index
			firstWallFlag = true
		end

		--ڐGĂ
		if _wallTouch == true then
			wallTouch = _wallTouch
		end
	end

	--ĂȂAڐGĂ
	if wallHitFlag == false and wallTouch == true then

		--o^Ă郊Xg}ĂƓ蔻
		for key, resource in pairs(self.mMapList) do

			--e|
			local _wallHitFlag = false

			--ǂƂ̓蔻
			GetMinMax(self.mPlayer.mPosition, 100, 50, 100, min, max) --lAABB߂
			if AABBJudgment(XFILE:GetXFile(resource), self.mMapMatrixList[key], min, max) then
				_wallHitFlag = SideToWall(charaPosition, charaDirection, 13, 2.5, resource, self.mMapMatrixList[key])
			end

			--ĂԂۑ
			if _wallHitFlag == true then
				wallHitFlag = true
				wallName = key
				break
			end
		end	
	end

	--蔻e[uɊi[
	self.mHitData.wallFlag = wallHitFlag
	self.mHitData.landFlag = landHitFlag
	self.mHitData.landType = landType
	self.mHitData.wallName = wallName
	self.mHitData.landName = landName
	self.mHitData.index    = index

	--ԂԂ
	return self.mHitData
end

--vC[W̒ւƐݒ肷yӂ蔻IuWFNg̖, ̌(p)\pxz
function map_scene:SetPlayerInDoor(doorHitName, angle)
	local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle) )
	local axisVec = TMP_VECTOR:Set(X_AXIS * 67):TransformCoord(rotY)
	local doorPos = TMP_VECTOR_A:Set(XFILE:GetXFile(XPath(doorHitName) ).mOBBCenter)
	axisVec.y = -4.5
	self.mPlayer.mPosition:Set(doorPos + axisVec)
end

--Xe[WޏoCxgyCxgXe[g, 蔻pIuWFNg, ̌(p)\pxz
function map_scene:RunExitEvent(eventName, doorHitName, angle)

	local matrix = TMP_MATRIX:Identity()
	local min    = TMP_VECTOR:Set(self.mPlayer.mPosition + TMP_VECTOR:Set(1, 1, 1) )
	local max    = TMP_VECTOR_A:Set(self.mPlayer.mPosition + TMP_VECTOR_A:Set(-1, -1, -1) )

	--CxgJn̏u
	if AABBJudgment(XFILE:GetXFile(XPath(doorHitName) ), matrix, min, max) then
		self[eventName]:Change(true)    --CxgJn
		self.mPlayer:Stop()             --vC[̓~
		self.mFade:Belt(true)           --f̂悤ȑтo
		self.mCamera:EnableMoving(true) --J̔Cӈړ
	end

	--oĂCxg
	if self[eventName].mFlag == true then

		--Jړ鏈ipxlāA鑊Έʒuֈړj
		if 30 <= self[eventName].mCount and self[eventName].mCount < 60+30 then
			local cnt = self[eventName].mCount - 30
			local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle) )
			local axisVec = TMP_VECTOR:Set(X_AXIS * 173.26):TransformCoord(rotY)
			local maxAt   = TMP_VECTOR_A:Set(XFILE:GetXFile(XPath(doorHitName) ).mOBBCenter)
			local maxPos  = TMP_VECTOR_B:Set(maxAt + axisVec)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--tF[hC
		if self[eventName].mCount == 60+30+20 then
			self.mFade:FadeIn("face", 10.0)
		end

		--loւ̈ړJn
		if 60+30 <= self[eventName].mCount and self[eventName].mCount < 60*3 then

			--oւ̈ړ
			local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle) )
			local axisVec = TMP_VECTOR:Set(X_AXIS * -1):TransformCoord(rotY)
			self.mPlayer:MoveDirection(Z_AXIS, axisVec.x, axisVec.z)
			self.mPlayer:ChangeSpeed(1.0)
		end

		--IꍇAV[ύXs
		if self[eventName].mCount == 60*3 then
			return true
		end
	end 

	--JEgAbv
	self[eventName]:CountUp(1)

	return nil
end

--Xe[WɐiCxgyCxgXe[g, 蔻pIuWFNg, ̌(p)\px, ␳lz
function map_scene:RunEnterEvent(eventName, doorHitName, angle, sub)

	--CxgJn̏u
	if self.mCount == 0 then
		self[eventName]:Change(true)    --CxgJn
		self.mFade:Belt(true)           --f̂悤ȑтo
		self.mCamera:EnableMoving(true) --J̔Cӈړ

		--Jwʒuֈړ
		local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle) )
		local axisVec = TMP_VECTOR:Set(X_AXIS * 173.26):TransformCoord(rotY)
		local maxAt   = TMP_VECTOR_A:Set(XFILE:GetXFile(XPath(doorHitName) ).mOBBCenter)
		local maxPos  = TMP_VECTOR_B:Set(maxAt + axisVec)
		self.mCamera:Move(maxPos, maxAt, 59, 59)
	end

	--CxgJn
	if self[eventName].mFlag == true then

		--l𓮂
		if 0 <= self[eventName].mCount and self[eventName].mCount < 20+60 then

			--Oւ̈ړ
			if sub == nil then sub = 1.0 end
			local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle * sub) )
			local axisVec = TMP_VECTOR:Set(X_AXIS):TransformCoord(rotY)
			self.mPlayer:MoveDirection(Z_AXIS, axisVec.x, axisVec.z)
			self.mPlayer:ChangeSpeed(1.0)
		end

		--J̓KWŎZo
		if self[eventName].mCount == 20+60+30 then
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
		end

		--Jʏ̈ʒu֖߂
		if 20+60 <= self[eventName].mCount and self[eventName].mCount < 20+60*2 then
			local cnt = 59 - (self[eventName].mCount - (20+60) )
			local rotY    = TMP_MATRIX:RotationY(DEG_ANGLE(angle) )
			local axisVec = TMP_VECTOR:Set(X_AXIS * 173.26):TransformCoord(rotY)
			local maxAt   = TMP_VECTOR_A:Set(XFILE:GetXFile(XPath(doorHitName) ).mOBBCenter)
			local maxPos  = TMP_VECTOR_B:Set(maxAt + axisVec)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end 

		--Cxg̏I
		if self[eventName].mCount == 20+60*2 then
			self.mFade:Belt(false)           --f̂悤ȑт
			self.mCamera:EnableMoving(false) --J̔CӈړI
			self[eventName]:Change(false)    --CxgI
		end
	end

	--JEgAbv
	self[eventName]:CountUp(1)
end

--lWCxgylW̃f, spiralIuWFNgϐ, fobO@\L[z
function map_scene:RunGetNeji(name, nejiItemName, debugKey)

	--lWʒu
	local nejiPos = TMP_VECTOR:Set(0, 10, 0)
	nejiPos:Set(self[nejiItemName].mPosition + nejiPos)

	--~āAlW擾
	if SphereJudgment(nejiPos, 25, self.mPlayer.mPosition, 0) or DEBUGINPUT[debugKey] == 1 then
		if game.data.now_neji ~= name then
			self:Shine(name)
			self.mPlayer:ChangeNeji(name)
			game.data.now_neji = name
			WAVESOUND:Play(WPath("item"), 0, 0)
		end
		self[nejiItemName]:Dismiss()
	end
end