
--XNvg[h
--_G.OnReload = function() print("stage00_scene _G.OnReload") end

--V[NX
Class("stage00_scene", map_scene)({})

--RXgN^
function stage00_scene:constructor(...)
	self.super:constructor(...)

	--oϐ
	self.mDoorOpenSize = 0                  --̊J
	self.mDoorEvent = state:factory()       --JCxg
	self.mEnterEvent = state:factory()      --ĂCxg
	self.mExitEvent = state:factory()       --oĂCxg
	self.mDoorOpenFlag = false              --hAJĂ邩
	self.mSwitchDownSize = 0                --XCb`ǂꂾł邩
	self.mDoorOpenCamPos = Vector3C()       --hAJCxgÕJʒu
	self.mDoorOpenCamAt = Vector3C()        --hAJCxgÕJ_

	--vC[̐ݒ
	if game.data.now_place == "place_B" then
		self:SetPlayerInDoor("stage00_door_hit", 180)
		self.mCamera:SetAngle(-90)
	else
		self.mPlayer.mPosition:Set(140, 900, -500)
		self.mCamera:SetAngle(0)
		for i = 0, 1 do
			self.mPlayer:MoveDirection(Z_AXIS, 0, -1)
			self.mPlayer:ChangeSpeed(1.0)
			self.mPlayer:Run()
		end
		
		--lWftHg
		game.data.now_neji = "normal"

		--BGM炷
		MP3SOUND:Play(MPath("main"), true, MilSecTo(0), MilSecTo(218608) )
		MP3SOUND:SetVolume(MPath("main"), -2000)
	end
	self.mPlayer:ChangeNeji(game.data.now_neji)

	--}bvǂݍ݁iLƂ̓蔻pj
	self.mMapList = {
		map0 = XPath("stage00_0"),
		map1 = XPath("stage00_1"),
		map2 = XPath("stage00_2"),
		map3 = XPath("stage00_3"),
		block = XPath("stage00_block"),
		door_a = XPath("stage00_door_a"),
		door_b = XPath("stage00_door_b"),
		switch_a_hit = XPath("stage00_switch_a_hit"),
		switch_b_hit = XPath("stage00_switch_b_hit"),
	}

	--}bṽ[hϊs쐬
	self.mMapMatrixList = {}
	for key, resource in pairs(self.mMapList) do
		self.mMapMatrixList[key] = MatrixC()
	end

	--}bv̕`IuWFNg쐬iJƂ̔ɂgpj
	self.mMapVisualList = {
		mMap0 = RENDERER:CreateModel(self.mMapList.map0),
		mMap1 = RENDERER:CreateModel(self.mMapList.map1),
		mMap2 = RENDERER:CreateModel(self.mMapList.map2),
		mMap3 = RENDERER:CreateModel(self.mMapList.map3),
		mBlock = RENDERER:CreateModel(self.mMapList.block),
		mSwitchA = RENDERER:CreateModel(XPath("stage00_switch_a") ),
		mSwitchB = RENDERER:CreateModel(XPath("stage00_switch_b") ),
		mDoorA = RENDERER:CreateModel(XPath("stage00_door_a") ),
		mDoorB = RENDERER:CreateModel(XPath("stage00_door_b") ),
	}

	--`IuWFNgɉet
	for key, model in pairs(self.mMapVisualList) do
		model:SetShader(SHADOWMAP)
	end

	--}bv̕`IuWFNg쐬
	for key, resource in pairs(self.mMapVisualList) do
		self[key] = resource
	end

	--tF[hAEg
	self.mFade:FadeOut("face", 10.0)

	--nP[ACe
	local itemPos = TMP_VECTOR:Set(-211, 100, 482)
	self.mHurricaneItem = spiral:factory("player_hurricane", spiral_hurricane, itemPos)

	--hANꍇ͊JĂ
	if game.data.now_place == "place_B" then self:OpenDoor() end

	--`惂f̌ݒ
	BASICSHADER:SetLightDirection(Vector3C(1.0, -1.0, 0.0) )
	SHADOWMAP:SetLightDirection(Vector3C(1.0, -1.0, 0.0) )

	--tHOݒ
	DEVICE:SetFogState(COLOR(255, 255, 170, 0), 100, 5500)

	--fobOL[ڍו\
	print([[*** fobOL[ڍו\ ***]])
	print(" [P]L[FWvlWɐ؂ւB")
	print(" [O]L[FJCxg𔭐B")
	print(" [I]L[Fς݂ɂB")
	print(" [U]L[Fef[^̉摜ۑB")
end

--s֐
function stage00_scene:Run()

	--V[JnBGM̃{[Xɏグ
	if self.mCount < 60 then
		MP3SOUND:SetVolume(MPath("main"), (-1500 / 60) * (60 - self.mCount) + self.mBGMDiff)
	end

	--fobOp
	if DEBUGINPUT.K_I == 1 then self:OpenDoor() end
	if DEBUGINPUT.K_U == 1 then SavePNG(SHADOWMAP:GetTextureData(), "_shadow_data.png") end

	--ړ
	local moveFlag = false

	--Cxgnn܂ĂȂ
	if self.mDoorEvent.mFlag == false and self.mExitEvent.mFlag == false and self.mEnterEvent.mFlag == false then

		--vC[ړ
		moveFlag = self:PlayerMove()

		--lWŗL̃ANV
		self:RunPlayerNejiAction()
	end
	
	--J̍XV
	local player = self.mPlayer --ȈՕ\Lp
	self.mCamera:Run(moveFlag, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)
	
	--vC[̍XV
	self.mPlayer:Run()

	--{NX̍XV
	self.super:Run()

	--nP[ACeXV
	self.mHurricaneItem:Run(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS)

	--O̒nʂƃvC[ڐGĂۑ
	self.mPlayer.mPreOnLandFlag = self.mPlayer.mOnLandFlag

	--vC[Wv̂݁AVƂ̓蔻s
	local jumpFlag = self.mPlayer.mJumpStartFlag

	--vC[ƃ}bv̓蔻
	local hitData = self:PlayerToMap(jumpFlag)

	--nʂƐڐGĂ
	self.mPlayer.mOnLandFlag = hitData.landFlag

	--fobOp
	if DEBUGINPUT.K_O == 1 then hitData.landName = "switch_a_hit" end

	--XCb`ăhAJCxg
	self:RunOpenDoor(hitData.landName)

	--WvlW擾Cxg
	self:RunGetNeji("hurricane", "mHurricaneItem", "K_P")

	--ĂCxgXV
	if game.data.now_place == "place_B" then
		self:RunEnterEvent("mEnterEvent", "stage00_door_hit", 0)
	end

	--oĂCxgiočs玟̃V[ցj
	local next = nil
	if self.mEnterEvent.mFlag == false then
		next = self:RunExitEvent("mExitEvent", "stage00_door_hit", 0)
		if next == true then
			game.data.now_scene = "stage01_scene"
			game.data.now_place = "place_A"
		end
	end

	--očsɉʂ
	if self.mExitEvent.mFlag == true and 120 < self.mExitEvent.mCount then
		local cnt = self.mExitEvent.mCount - 120
		MP3SOUND:SetVolume(MPath("main"), (-5000 / 60) * cnt + self.mBGMDiff)
	end

	--r[sݒ
	view = MatrixC:MkLookAtLH(self.mCamera.mPosition, self.mCamera.mAt, Y_AXIS)
	DEVICE:SetViewMatrix(view)

	--̊Kɉe`悳Ȃ悤ɐ؂ւ鏈
	local min = TMP_VECTOR
	local max = TMP_VECTOR_A
	GetMinMax(self.mPlayer.mPosition, 50, 100, 50, min, max) --lAABB߂
	if AABBJudgment(XFILE:GetXFile(self.mMapList.map3), self.mMapMatrixList["map3"], min, max) then
		self.mMap3:SetShader(SHADOWMAP)
	else
		self.mMap3:SetShader(BASICSHADER)
	end
	if AABBJudgment(XFILE:GetXFile(self.mMapList.map2), self.mMapMatrixList["map2"], min, max) then
		self.mMap2:SetShader(SHADOWMAP)
	else
		self.mMap2:SetShader(BASICSHADER)
	end
	if 207 < self.mPlayer.mPosition.x then
		self.mMap2:SetShader(SHADOWMAP)
		self.mMap3:SetShader(SHADOWMAP)
	end

	--_Os
	DEVICE:BeginRendering()

	--vC[̉ef[^̍쐬
	self:SetShadowSetting()

	--`
	RENDERER:Draw(self.mCamera.mPosition, self.mCamera.mAt)
	local lostFlag = DEVICE:EndRendering()

	--foCX̃Xg
	if lostFlag == true then

		--foCX̏Ԃ邽߁AĐݒs
		self.mLight:Initialize() --
		self.mLight:SetDirection(Vector3C(1.0, -1.0, 0.0):Normalize() )
		self.mLight:Apply()
	end

	--fobOo
	if INI_DEBUG_MODE == true then self:DebugMessage() end

	--JEgAbv
	self.mCount = self.mCount + 1

	--V[̕ύX邩
	return next
end

--fXgN^iOR[j
function stage00_scene:destructor()
	self.super:destructor()
end

--[h֐
function stage00_scene:OnReload()
end

--hAJCxgy̖Oz
function stage00_scene:RunOpenDoor(landName)

	--XCb`AhAJCxgJn
	if landName == "switch_a_hit" and self.mDoorOpenFlag == false then
		self.mDoorEvent:Change(true) --hAJCxgJn
		self.mDoorOpenFlag = true    --hA͊JĂ
	end

	--hAJCxg
	if self.mDoorEvent.mFlag == true then

		--CxgJnu
		if self.mDoorEvent.mCount == 0 then
			self.mPlayer:Stop()             --vC[̓~
			self.mFade:Belt(true)           --f̂悤ȑтo
			self.mCamera:EnableMoving(true) --J̔Cӈړ\ɂ
		end

		--BGM̃{[
		if 5 <= self.mDoorEvent.mCount and self.mDoorEvent.mCount <= 60 + 5 then
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * self.mDoorEvent.mCount + self.mBGMDiff)
		end
		
		--XCb`ݍޏ
		if 5 <= self.mDoorEvent.mCount and self.mDoorEvent.mCount <= 15 then
			
			--ꎞϐ
			local switchTrans = TMP_MATRIX
			local switchTrans2 = TMP_MATRIX_A

			--XCb`̒݋쐬
			self.mSwitchDownSize = self.mSwitchDownSize - 2.1
			switchTrans:Translation(0, self.mSwitchDownSize, 0)

			--JEgAXCb`𒾂܂
			if 11 <= self.mDoorEvent.mCount then
				switchTrans2:Translation(0, self.mSwitchDownSize, 0)
			else
				switchTrans2:Translation(0, 0, 0)
			end
			self.mSwitchA:SetMatrix(switchTrans)
			self.mMapMatrixList.switch_a_hit:Set(switchTrans2)

			--XCb`މ炷
			if 15 == self.mDoorEvent.mCount then
				WAVESOUND:Play(WPath("switch"), Vector3C(-282, 360, -552), ZERO_VECTOR, 150, 200)
			end
		end

		--Jړ鏈iwʒuֈړj
		if 60 <= self.mDoorEvent.mCount and self.mDoorEvent.mCount < 60*2 then
			local cnt = self.mDoorEvent.mCount - 60
			local maxPos = TMP_VECTOR:Set(191, 465, 323)
			local maxAt = TMP_VECTOR_A:Set(72, 410, 232)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)
		end

		--hAJ
		if 60*2 <= self.mDoorEvent.mCount and self.mDoorEvent.mCount < 60*4 then

			local doorTrans  = TMP_MATRIX
			local doorTrans2 = TMP_MATRIX_A
			local dirtyPos   = TMP_VECTOR

			self.mDoorOpenSize = self.mDoorOpenSize + 0.5
			doorTrans:Translation(-3, 0, self.mDoorOpenSize * -1.0)
			doorTrans2:Translation(-3, 0, self.mDoorOpenSize)
			self.mDoorA:SetMatrix(doorTrans)
			self.mDoorB:SetMatrix(doorTrans2)
			self.mMapMatrixList.door_a:Set(doorTrans)
			self.mMapMatrixList.door_b:Set(doorTrans2)

			--ỹp[eBNo
			if self.mDoorEvent.mCount % 10 == 0 then
				local min = 1 + math.floor(self.mDoorOpenSize / (60/4) )
				for i = min, 4 do
					
					--
					dirtyPos:Set(-110, 358, 206 + i*9)
					self:DirtyDust(dirtyPos, 8, 40, 0.7, 0.1)
					dirtyPos:Set(-110, 358, 206 - i*9)
					self:DirtyDust(dirtyPos, 8, 40, 0.7, 0.1)
				end

				--
				if self.mDoorEvent.mCount < 60*3 then
					for i = 0, 20 do
						dirtyPos:Set(-110, 358 + i*4, 206 + 40)
						self:DirtyDust(dirtyPos, 5, 40, 0.35, 0.0)
						dirtyPos:Set(-110, 358 + i*4, 206 - 40)
						self:DirtyDust(dirtyPos, 5, 40, 0.35, 0.0)
						dirtyPos:Set(-130, 358 + i*4, 206 + 40)
						self:DirtyDust(dirtyPos, 5, 40, 0.35, 0.0)
						dirtyPos:Set(-130, 358 + i*4, 206 - 40)
						self:DirtyDust(dirtyPos, 5, 40, 0.35, 0.0)
					end
				end
			end

			--J
			if self.mDoorEvent.mCount % 30 == 0 and self.mDoorEvent.mCount < 60*3 then
				WAVESOUND:Play(WPath("gogogo"), Vector3C(-110, 358, 206), ZERO_VECTOR, 150, 200)
			end

			--J鉹
			if self.mDoorEvent.mCount == 60*4 - 15 then
				WAVESOUND:Play(WPath("don"), Vector3C(-110, 358, 206), ZERO_VECTOR, 150, 200)
			end
			if self.mDoorEvent.mCount == 60*4 - 17 then
				WAVESOUND:Play(WPath("don"), Vector3C(-110, 358, 206), ZERO_VECTOR, 150, 200)
			end

			--
			if self.mDoorEvent.mCount == 60*4 - 1 then
				WAVESOUND:Play(WPath("mystery"), -700, 0)
			end
		end

		--Jړ鏈iwʒuJnj
		if self.mDoorEvent.mCount == 60*6+30 then

			--J̓KWŎZo
			local player = self.mPlayer
			self.mCamera:GetPosAt(false, false, player.mPosition, player.mAngle, player:GetUnitSpeed(), self.mMapVisualList)

			--̓蔻肾ցi댟oj
			local doorTrans = TMP_MATRIX:Translation(-300, 0, 0)
			self.mMapMatrixList.door_a:Set(doorTrans)
			self.mMapMatrixList.door_b:Set(doorTrans)
		end

		--Jړ鏈ïʒuֈړj
		if 60*6+30 <= self.mDoorEvent.mCount and self.mDoorEvent.mCount < 60*7+30 then
			local cnt = 59 - (self.mDoorEvent.mCount - (60*6+30) )
			local maxPos = TMP_VECTOR:Set(191, 465, 323)
			local maxAt = TMP_VECTOR_A:Set(72, 410, 232)
			self.mCamera:Move(maxPos, maxAt, 59, cnt)

			--BGM̃{[グ
			MP3SOUND:SetVolume(MPath("main"), (-1000 / 60) * cnt + self.mBGMDiff)
		end

		--Cxg̏I
		if self.mDoorEvent.mCount == 60*7+30 then
			self.mFade:Belt(false)           --f̂悤ȑт
			self.mCamera:EnableMoving(false) --J̔CӈړI
		end

		--hAJCxgI
		if (60*7+30) < self.mDoorEvent.mCount then
			self.mDoorEvent:Change(false)
		end

	end

	--JEgAbv
	self.mDoorEvent:CountUp(1)
end

--JiJCxgȈԂɂj
function stage00_scene:OpenDoor()

	--ꎞϐ
	local doorTrans   = TMP_MATRIX
	local doorTrans2  = TMP_MATRIX_A
	local switchTrans = TMP_MATRIX_B
	
	--hAJCxgIԂɂ
	self.mDoorEvent:Set(true, 60*8, 0)
	self.mDoorOpenFlag = true

	--XCb`𒾂܂
	self.mSwitchDownSize = self.mSwitchDownSize - (2.1 * 11)
	switchTrans:Translation(0, self.mSwitchDownSize, 0)
	self.mSwitchA:SetMatrix(switchTrans)
	self.mMapMatrixList.switch_a_hit:Set(switchTrans)

	--J
	self.mDoorOpenSize = 0.5 * 60 * 2
	doorTrans:Translation(-3, 0, self.mDoorOpenSize * -1.0)
	doorTrans2:Translation(-3, 0, self.mDoorOpenSize)
	self.mDoorA:SetMatrix(doorTrans)
	self.mDoorB:SetMatrix(doorTrans2)
	self.mMapMatrixList.door_a:Set(doorTrans)
	self.mMapMatrixList.door_b:Set(doorTrans2)

	--̓蔻肾ցi댟oj
	doorTrans:Translation(-300, 0, 0)
	self.mMapMatrixList.door_a:Set(doorTrans)
	self.mMapMatrixList.door_b:Set(doorTrans)
end
